#! /bin/sh
### BEGIN INIT INFO
# Provides:          inoticoming
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript for inoticoming
# Description:       This script provides an example how to start an instance
#                    of inoticoming via an initscript. Place this file in
#                    /etc/init.d, e.g. as /etc/init.d/inoticoming, and define
#                    your settings in /etc/default/inoticoming.
### END INIT INFO

# Copyright (c) 2008 by Tilman Koschnick <til@subnetz.org>
# Based on /etc/init.d/skeleton from Debian package initscripts
# Distributed under the GPLv2

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="incoming queue monitor"
NAME=inoticoming
DAEMON=/usr/bin/inoticoming
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

INITIALSEARCH=0
LOGGROUP="adm"
USER=""
GROUP=""
LOGFILE=""
ACTIONS=""
DIR="/"

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started

	if [ -z "$USER" ] ; then
		echo "No user set, cannot start inoticoming!" >&2
		return 2
	fi
	if [ -z "$GROUP" ] ; then
		echo "No group set, cannot start inoticoming!" >&2
		return 2
	fi

	# make sure inoticoming can write the PID to $PIDFILE
	[ -f "$PIDFILE" ] || touch "$PIDFILE"
	chown "$USER":"$GROUP" "$PIDFILE" || return 2
	set -- --pid-file "$PIDFILE"

	# make sure inoticoming can write to $LOGFILE
	if [ -n "$LOGFILE" ] ; then
		[ -f "$LOGFILE" ] || touch "$LOGFILE"
		if [ -n "$LOGGROUP" ] ; then
			chown "$USER":"$LOGGROUP" "$LOGFILE" || return 2
		else
			chown "$USER":"$GROUP" "$LOGFILE" || return 2
		fi
		set -- "$@" --logfile "$LOGFILE"
	fi

	# should we do an initial search of the directory?
	[ "$INITIALSEARCH" != "0" ] && set -- "$@" --initialsearch

	start-stop-daemon --start --quiet --pidfile "$PIDFILE" --exec "$DAEMON" --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile "$PIDFILE" --exec "$DAEMON" --chuid "$USER":"$GROUP" -- \
		"$@" "$DIR" $ACTIONS \
		|| return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --pidfile "$PIDFILE"
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	rm -f -- "$PIDFILE"
	return "$RETVAL"
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  restart|force-reload)
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
	exit 3
	;;
esac

:
